#region Copyright
/*
 * Copyright 2005 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace Seasar.Controls.Win.Logic.Impl
{
	/// <summary>
	/// GraphicsWbN̎NXł
	/// </summary>
	public class GraphicsLogicImpl : IGraphicsLogic
	{
		public GraphicsLogicImpl()
		{
		}

        #region IXPButtonLogic o
        
        /// <summary>
        /// GDI+ `ʂ̍̈ʒuɎw肳ꂽTCY̎lp`̓hԂ܂
        /// </summary>
        /// <param name="graphics">GDI+ `</param>
        /// <param name="color">F</param>
        /// <param name="size">TCY</param>
        public void PaintSquare(Graphics graphics, Color color, Size size)
        {
            graphics.FillRectangle(new SolidBrush(color), 0, 0, size.Width, size.Height);
        }

        /// <summary>
        /// GDI+ `ʂɎw肳ꂽlp`̓hԂ܂
        /// </summary>
        /// <param name="graphics">GDI+ `</param>
        /// <param name="color">hԂF</param>
        /// <param name="rect">hԂ͈́ilp`j</param>
        public void PaintSquare(Graphics graphics, Color color, Rectangle rect)
        {
            // uV쐬܂
            Brush brush = new SolidBrush(color);

            // lp`hԂ܂
            graphics.FillRectangle(brush, rect);
        }

        /// <summary>
        /// `Of[VœhԂ܂
        /// </summary>
        /// <param name="g">GDI+ `</param>
        /// <param name="rect">`Of[V͈̔</param>
        /// <param name="path">hԂg</param>
        /// <param name="color1">Of[V̊JnF</param>
        /// <param name="color2">Of[V̏IF</param>
        public void PaintGradient(Graphics graphics, Rectangle rect, GraphicsPath path, Color color1, Color color2)
        {
            // `Of[ṼuV쐬܂
            using(LinearGradientBrush brush = new LinearGradientBrush(rect,
                      color1, color2, LinearGradientMode.Vertical))
            {
                // uVœhԂ܂
                graphics.FillPath(brush, path);
            }
        }

        /// <summary>
        /// lp`̃hbgg`܂
        /// </summary>
        /// <param name="graphics">GDI+ `</param>
        /// <param name="rect">g`g</param>
        /// <param name="color">g̐F</param>
        public void DrawSquareDotDashLine(Graphics graphics, Rectangle rect, Color color)
        {
            // y쐬܂
            Pen pen = new Pen(color);

            // hbgō\gw肵܂
            pen.DashStyle = DashStyle.Dot;

            // lp`̃hbgg`܂
            graphics.DrawRectangle(pen, rect);
        }

        /// <summary>
        /// ̐FZeF쐬܂
        /// </summary>
        /// <param name="color">F</param>
        /// <returns>eF</returns>
        public Color CreateShadeColor(Color color)
        {
            byte[] argb = new byte[] {color.A, color.R, color.G, color.B };
            argb[0] = CreateShadeByte(argb[0]);
            argb[1] = CreateShadeByte(argb[1]);
            argb[2] = CreateShadeByte(argb[2]);
            argb[3] = CreateShadeByte(argb[3]);
            return Color.FromArgb(argb[0], argb[1], argb[2], argb[3]);
        }

        #endregion

        #region Private Method

        /// <summary>
        /// byteeFƂȂbyteԂ܂
        /// </summary>
        /// <param name="from"></param>
        /// <returns></returns>
        private byte CreateShadeByte(byte from)
        {
            from -= 30;
            if(from < 0) from = 0;
            return from;
        }

        #endregion
	}
}
